function calcnebularluminosity, sfr=sfr, gasmetal=gasmetal, q=q, $
   lines=lines, linewav=linewav  ; outputs

  ; has diverged from the one used in buildgalaxy - is better but can't be substituted back in

  common kewleyblock, kewley
  
  if n_elements(kewley) eq 0 then kewley = readkewley()

  x = alog10(gasmetal)+8.69           ; x = [log[O/H]+12], solar is 8.69 (Asplund)
  if n_elements(q) eq 0 then q = 3d7  ; supposedly typical from Kewley

  lines = ['Halpha', 'Hbeta', 'Hgamma','Hdelta','Hepsilon','Hzeta', 'Lyalpha',$ 
           '[OII]1','[OII]2', '[OIII]1','[OIII]2', '[NII]1','[NII]2',  '[SII]1', '[SII]2', '[OII]']
  linewav = [6562.82,4861.33,4340.5,4101.7,3970.1,3889.1,          1217., $   
             3726.1,3728.8,    4958.91,5006.84,      6548.06,6583.57,   6716.44,6730.82,  3727.]
 
  linelumh = 1.255d+41*[1., 1./2.86, 1/6.08, 1./(2.86/0.260), 1./(2.86/0.159), 1./(2.86/0.105)] 
   ; http://www.naoj.org/Science/Resources/lines/hi.html , itself from Hummer & Storey (1987; MNRAS 224, 801).
   ; original reference is probably Kennicutt, Tamblyn, & Congdon (1994)

  linelumlya = 8.7 * linelumh[0] ; Dijkstra & Westra

  k = igrid(kewley.oiihalpha, kewley.q, q)
  linelumoii = 1.265d+41*poly(x,k) * [0.5,0.5]
  if x lt 8.2 then linelumoii = 1.265d+41*poly(8.2,k) * [0.5,0.5] * 10.^(x-8.2)
    ; Kewley OII/Halpha goes negative eventually, and the grid doesn't deal with metallicity below 8.2...
    ; going to need to look into this later...!
    ; these come from Fig 9 / Table 4 of Kewley 2004

  k = igrid(kewley.logoiiioii, kewley.z, gasmetal)
  linelumoiii =  total(linelumoii) * 10.0^(poly(alog10(q),k)) * [0.3333,1.0] ;  formerly 0.2

  ; previously was scaling nii to oii instead of Halpha for some strange reason.
  ;k = igrid(kewley.logniioii, kewley.q, q)
  ;linelumnii = total(linelumoii) * 10.0^(poly(x,k)) * [0.3,1.0]
  k = igrid(kewley.logniihalpha, kewley.q, q)
  linelumnii = linelumh[0] * 10.0^(poly(x,k)) * [0.339,1.0]   

  k = igrid(kewley.logniisii, kewley.q, q)
  linelumsii = linelumnii[1] / 10.0^(poly(x,k)) * [0.6,0.4]

  outlinelum = [linelumh, linelumlya, linelumoii, linelumoiii, linelumnii, linelumsii, total(linelumoii)]
  outlinelum = outlinelum*sfr 
           ;/ 3.839d+33  ; where does this come from?  (Kennicutt?)
           ; evidently this is an adjustment to prepare for conversion to f_nu, so not necessary now

  return, outlinelum

end

