pro checknebplot, par=par
  NZ = 300
  q = [5e6, 1e7, 2e7, 4e7, 8e7, 1.5e8, 3e8]
  c = [rgb(128,0,128), rgb(0,0,255), rgb(0,200,255), rgb(0,200,0), rgb(180,200,0), rgb(250,70,0), rgb(255,0,0)]
  logZ = 7.5+1.9*findgen(NZ)/(NZ-1)
  val = dblarr(NZ)
  ;o3b = dblarr(NZ)
  ;o3a = dblarr(NZ)
  ;o2 = dblarr(NZ)
  ;n2 = dblarr(NZ)
  ;hbeta = fltarr(NZ)
  if par eq 'n2halpha' then yrange=[-3,0.0]
  if par eq 'r23' then yrange=[-2,2]
  if par eq 'o3o2' then yrange=[-2,2]
  if par eq 'n2o3' then yrange=[-3,4]
  plot, logZ, logZ+0, yrange=yrange, /xsty, /ysty

  for j = 0, n_elements(q)-1 do begin
    for i = 0, n_elements(logZ)-1 do begin
      l = (calcnebularluminosity(sfr=1.0, gasmetal=10.0^(logZ[i]-8.69), q=q[j])) ; 8.69 assumed in the code
      ;o2[i] = l[7]+l[8]
      ;print, o2[i], o3a[i]
      ;o3b[i] = l[9] 
      ;o3a[i] = l[10]
      ;n2[i] = l[12]
      ;ha[i] = l[0]
      if par eq 'n2halpha' then val[i] = l[12]/l[0]
      if par eq 'r23' then val[i] = (l[7]+l[8]+l[9]+l[10])/l[1]
      if par eq 'o3o2' then val[i] = (l[10])/(l[7]+l[8])
      if par eq 'n2o3' then val[i] = l[12]/l[10]
    endfor
    ;oplot, logZ, alog10(poly(logZ, [-2281.80, 754.840, -82.8388, 3.01667])) ; OII/Halpha for q=2e7 direct from K04
    oplot, logZ, alog10(val), color=c[j]
  endfor
end
