function    igm_atten,lambda,z
;
; computes igm attenuate (0,1) as a function of observed wavelength
;  lambda (Angstroms) on a defined grid of redshifts z.
;
; prescription used is that of Madau as in the hyper-z code.
if (n_elements(z) eq 0) then z=0.

nz=n_elements(z) & nl=n_elements(lambda)
res=dblarr(nl,nz)

dfac = madau_opacity(z)

lam0=[0.,892.,902.,912.,(920.+1015.)/2.,(1050+1170.)/2.,1220.,1230.,1240.,1.d9]

for i=0.,nz-1 do begin
  y0 = [0.,0.,0.,0.,dfac(*,i),1.,1.,1.,1.] 
  res(*,i) = (interpol( y0,lam0,lambda/(1+z(i)) )>0.)<1.
endfor

return, res

end
