function    pDA,lam
;
return, exp(-3.6d-3*(lam/1216.)^3.46)/120.
end

function    pDB,lam
;
AA=[1.7d-3, 1.2d-3, 9.3d-4]
lam0 = [1026.d,973.,950]
return, exp( -total( AA*(lam/lam0)^3.46 ) )/95.
end

function    madau_opacity,z
;
; returns attenuation in two bands:
;   105-117 nm  and  92-101.5 nm
;   (flux is 0 below 91.2 nm)
;
nz=n_elements(z)
Dfac=dblarr(2,nz)

for i=0.,nz-1 do begin
    Dfac(1,i) = qgauss('pDA',1050*(1.+z(i)),1170*(1.+z(i)))/(1.+z(i))
    Dfac(0,i) = qgauss('pDB',920*(1.+z(i)),1015*(1.+z(i)))/(1.+z(i))
endfor

return,Dfac

end
