function galaxyfiltflux, f, p

  ; Calculates the flux of a galaxy in several broadband filters for SED fitting.
  ; f = filters
  ; p = parameters

   ; all parameters must be positive.  a negative parameter means use the internal default.

   freq = 10.0^(7*findgen(1000)/1000.) ; GHz
   if p[0] ge 0. then   z = p[0]
   if p[1] ge 0. then   sfr = p[1]
   if p[2] ge 0. then   age = p[2]
   if p[3] ge 0. then   model = 'cont' ;!
   if p[4] ge 0. then   texp = p[4]
   if p[5] ge 0. then   metallicity = p[5]
   if p[6] ge 0. then   mass = p[6]
   if p[7] ge 0. then   embedfrac = p[7]
   if p[8] ge 0. then   av = p[8]
   if p[9] ge 0. then   embedav = p[9]
   if p[10] ge 0. then  dustlaw = 'Calz' ;!
   if p[11] ge 0. then  rv = p[11]
   if p[12] ge 0. then  Tdust = p[12]

   ;print, 'function call'
   ;for i = 0, n_elements(p)-1 do begin
   ;  print, i, p[i]
   ;endfor
   ;print, p

   buildgalspec, freq, fnu, z=z, $
                 sfr=sfr, age=age, model=model, texp=texp, metallicity=metallicity, mass=mass, $
                 embedfrac=embedfrac, av=av, embedav=embedav, dustlaw=dustlaw, rv=rv, $
                 Tdust=Tdust
                ; Lbol=Lbol, Lir=Lir, apparentmass=apparentmass, apparentSFR=apparentSFR

   print, 'z='+fpr(z,1.3)+' sfr='+clip(sfr)+'  age='+epr(age,2)+'  Zs='+fpr(metallicity,1.3)+$
          '  M='+epr(mass,2)+'  fe='+fpr(embedfrac,1.2)+'  Av='+fpr(av,1.3)+'  eav='+fpr(embedav,2.2)+$
          '  Rv='+fpr(rv,1.2)+'  T='+fpr(Tdust,2.2)


   flux = fltarr(n_elements(f))
   wav = 3e+9/freq
   oplot, wav, fnu
   for i = 0, n_elements(f)-1 do begin
      flux[i] = synflux(wav, fnu, f[i])
   endfor

   ;print, flux

   return, flux

end

