pro galaxyflux, freq, fnu, p

  ; freq and fnu are both outputs.  You should change this (or, rather, split off versions)

  ; Calculates the flux of a galaxy in several broadband filters for SED fitting.
  ; w = wavelengths
  ; p = parameters

   ; all parameters must be positive.  a negative parameter means use the internal default.

   freq = 10.0^(7*findgen(1000)/1000.) ; GHz
   if p[0] ge 0. then   z = p[0]
   if p[1] ge 0. then   sfr = p[1]
   if p[2] ge 0. then   age = p[2]
   if p[3] ge 0. then   model = 'const' ;!
   if p[4] ge 0. then   texp = p[4]
   if p[5] ge 0. then   metallicity = p[5]
   if p[6] ge 0. then   mass = p[6]
   if p[7] ge 0. then   embedfrac = p[7]
   if p[8] ge 0. then   av = p[8]
   if p[9] ge 0. then   embedav = p[9]
   if p[10] ge 0. then  dustlaw = 'Calz' ;!
   if p[11] ge 0. then  rv = p[11]
   if p[12] ge 0. then  Tdust = p[12]

   ;print, 'function call'
   ;for i = 0, n_elements(p)-1 do begin
   ;  print, i, p[i]
   ;endfor
   print, p

   buildgalspec, freq, fnu, z=z, $
                 sfr=sfr, age=age, model=model, texp=texp, metallicity=metallicity, mass=mass, $
                 embedfrac=embedfrac, av=av, embedav=embedav, dustlaw=dustlaw, rv=rv, $
                 Tdust=Tdust
                ; Lbol=Lbol, Lir=Lir, apparentmass=apparentmass, apparentSFR=apparentSFR

end

