function mkparinfo, bbinp, bbfix, minage=minage, maxage=maxage

  ;; 
  ; no parameters are allowed to be negative: negative means default value

   ppos = ppos()
   npar = ppos.npar
   
   if n_elements(minage) eq 0 then minage = 0

   parinfo = replicate({value:-1.0, fixed:0, limited:[1,0], limits:[0.,0.]}, npar)

   parinfo[ppos.tav].limited = [1,1]
   parinfo[ppos.tav].limits = [minage[0],minage[0]+(maxage-minage[0])/2.]
   parinfo[ppos.age].limited = [1,1]
   parinfo[ppos.age].limits = [minage[0],maxage]
   parinfo[ppos.age2].limited = [1,1]
   if n_elements(minage) gt 1 then parinfo[ppos.age2].limits = [minage[1],maxage]
   parinfo[ppos.q].limited = [1,1]
   parinfo[ppos.q].limits = [5e6, 3e8]
   parinfo[ppos.mass].limits = [1,0]
   parinfo[ppos.fembed].limited = [1,1]
   parinfo[ppos.fembed].limits = [0,1]
   parinfo[ppos.metal].limited = [1,1]
   parinfo[ppos.metal].limits =  [0.005,2.5]
   parinfo[ppos.gasmetal].limited = [1,1]
   parinfo[ppos.gasmetal].limits = [1e-3,10]
   parinfo[ppos.tau].limited = [1,0]
   parinfo[ppos.tau].limits = [0,0]
   parinfo[ppos.tsmooth].limited = [1,0]
   parinfo[ppos.tsmooth].limits = [0,0]

   parinfo[ppos.z].value =       bbinp.z
   parinfo[ppos.metal].value =   bbinp.metal
   parinfo[ppos.sfr].value =     bbinp.sfr
   parinfo[ppos.tav].value =     bbinp.tav
   parinfo[ppos.age].value =     bbinp.age
   parinfo[ppos.age2].value =    bbinp.age2
   parinfo[ppos.mass].value =    bbinp.mass
   parinfo[ppos.tau].value =     bbinp.tau
   parinfo[ppos.tsmooth].value = bbinp.tsmooth
   parinfo[ppos.dustlaw].value = where(extmap() eq strlowcase(bbinp.dustlaw))
   parinfo[ppos.av].value =      bbinp.av
   parinfo[ppos.avembed].value = bbinp.avembed
   parinfo[ppos.fembed].value =  bbinp.fembed
   parinfo[ppos.rv].value =      bbinp.rv
   parinfo[ppos.Tdust].value =   bbinp.Tdust
   parinfo[ppos.q].value =       bbinp.q
   parinfo[ppos.gasmetal].value= bbinp.gasmetal
   parinfo[ppos.L].value=        bbinp.L

   parinfo[ppos.z].fixed =       bbfix.z
   parinfo[ppos.metal].fixed =   bbfix.metal
   parinfo[ppos.sfr].fixed =     bbfix.sfr
   parinfo[ppos.tav].fixed =     bbfix.tav
   parinfo[ppos.age].fixed =     bbfix.age
   parinfo[ppos.age2].fixed =    bbfix.age2
   parinfo[ppos.mass].fixed =    bbfix.mass
   parinfo[ppos.tau].fixed =     bbfix.tau
   parinfo[ppos.tsmooth].fixed = bbfix.tsmooth
   parinfo[ppos.dustlaw].fixed = 1
   parinfo[ppos.av].fixed =      bbfix.av
   parinfo[ppos.avembed].fixed = bbfix.avembed
   parinfo[ppos.fembed].fixed =  bbfix.fembed
   parinfo[ppos.rv].fixed =      bbfix.rv
   parinfo[ppos.Tdust].fixed =   bbfix.Tdust
   parinfo[ppos.q].fixed =       bbfix.q
   parinfo[ppos.gasmetal].fixed =bbfix.gasmetal
   parinfo[ppos.L].fixed=        bbfix.L

   parinfo[where(parinfo[*].value lt 0)].fixed = 1 ; always fix these
   parinfo[where(parinfo[*].value lt 0)].limited = [0,0]

   parinfo[where(parinfo[*].fixed)].limited = [0,0]

   return, parinfo

end

