; a near direct copy of readhostphot, for the new galsedfit


function readgalphot, infile, galaxies=galaxies, limflux=limflux, minunc=minunc, addunc=addunc, limsigma=limsigma, loud=loud, rdate=rdate

if n_elements(limsigma) eq 0 then limsigma = 2.0

openr, 1, infile
iline = ''
nlines = 0
while not eof(1) do begin
  readf, 1, iline
  nlines = nlines + 1
endwhile
close, 1

obs = replicate({galaxy: '', filter:'', wav:0.0,  emag:0.0, stdmag:0.0, abmag:0.0, $
                 uplim:0, flux:0.0, fluxerr:0.0, fwhmwav:0.0, tel:'', date:'', ref:'', nofit:0},nlines)

galaxies = replicate({index:'', z:0.0, ebv:0.0, d1:'', d2:'', d3:''},nlines)

o = 0
g = 0

openr, 1, infile
for l = 0, nlines-1 do begin
  readf, 1, iline

  ; ignore leading/trailing spaces
  iline = strtrim(iline,2)

  ; ignore blank lines and comments
  if strlen(iline) eq 0 then continue
  if strmid(iline,0,1) eq '#' then continue
  iline = (strsplit(iline,'#',/extract)) [0]
  if strlen(iline) le 1 then continue

  if strmid(iline,0,3) eq 'GRB' or strmid(iline,0,3) eq 'PTF' or strmid(iline,0,2) eq 'SN' or strmid(iline,0,1) eq '*' then begin
    ilinearr = strsplit(iline,/extract)
    galaxy = ilinearr[1]
    if ilinearr[2] ne '?' then z = strnum(ilinearr[2]) else z = '?'
    ebv = strnum(ilinearr[3])

    galaxies[g].index = galaxy
    if clip(z) ne '?' then galaxies[g].z = strnum(z)
    galaxies[g].ebv = ebv
    if n_elements(ilinearr) gt 4 then galaxies[g].d1 = ilinearr[4]
    if n_elements(ilinearr) gt 5 then galaxies[g].d2 = ilinearr[5]
    if n_elements(ilinearr) gt 6 then galaxies[g].d3 = ilinearr[6]

    ;print, 'galaxy', galaxy, '    z=',clip(z), '  E(B-V)=',clip(ebv)

    g = g + 1
  endif else begin
    if strmid(iline,0,1) eq 'X' then begin
       iline = (strsplit(iline,'X',/extract)) [0]
       obs[o].nofit = 1
    endif
    ilinearr = strsplit(iline,/extract)
    filter = ilinearr[0]

    ; special fork for line fluxes
    if strlen(filter) ge 2 then if strmid(filter,0,2) eq 'H_' or strmid(filter,0,1) eq '[' then begin
       obs[o].galaxy  = galaxy
       obs[o].filter = filter
       wav = float(ilinearr[1])
       influx = float(ilinearr[2])   
       influxerr = float(ilinearr[3])
       fm_unred, wav, influx, ebv       ; looks like it always corrects for extinction regardless of yes/no
       fm_unred, wav, influxerr, ebv
       obs[o].flux = influx
       obs[o].fluxerr = influxerr
       o = o + 1
       continue ; everything else is left at zero.  no lower limits permitted, yet.
    endif
    
    mag = ilinearr[1]
    emag = ilinearr[2]
    refsys = ilinearr[3]
    extcor = ilinearr[4]

    if n_elements(ilinearr) gt 5 then tel = ilinearr[5] else tel = ''

    date = ''
    ref = ''
    if keyword_set(rdate) eq 0 and n_elements(ilinearr) gt 6 then ref  = ilinearr[6]
    if keyword_set(rdate) ge 1 and n_elements(ilinearr) gt 6 then date = ilinearr[6]
    if keyword_set(rdate) ge 1 and n_elements(ilinearr) gt 7 then ref =  ilinearr[7]
    if ref eq '--' then ref = 'This work'

    uplim = 0
    if strmid(mag,0,1) eq '>' then begin
      uplim = 1
      mag = strmid(mag,1)
    endif
    if strmid(mag,0,1) eq '=' then mag = strmid(mag,1)

    if strmid(extcor,0,1) eq 'y' then isextcor = 1 else isextcor = 0

    ; special for wavlength+mag
    if strmid(filter,0,2) eq 'l=' then begin ; seems to be legal for short strings
       wav = float(strmid(filter,2))*10000. ; um->Ang
       fwhm = 0.
    endif else begin            
       wav = filtwv(filter,fwhm=fwhm)
    endelse

    ext = (extinction(wav, 3.1, ebv*3.1)) [0]
    mag = float(mag)
    if emag eq '-'  then begin 
       if uplim eq 0 then emag = 0.25 else emag = 0.0
    endif else begin
       emag = float(emag) 
       if n_elements(minunc) gt 0 then emag = emag > minunc
       if n_elements(addunc) gt 0 then emag = sqrt(emag^2 + addunc^2)
    endelse
    if isextcor eq 0 and refsys eq 'AB' then mag = mag - ext  ;  AB mag should be corrected
    if isextcor eq 1 and refsys ne 'AB' then mag = mag + ext  ; std mag should be uncorrected
    if refsys eq 'AB' then begin
      abmag  =  mag
      stdmag =  ujy2mag(mag2ujy(mag,'AB'),filter)+ext
    endif else begin
      abmag = ujy2mag(mag2ujy(mag-ext,filter),'AB')
      stdmag = mag
    endelse
    obs[o].galaxy  = galaxy
    obs[o].filter = filter
    obs[o].wav = wav
    obs[o].fwhmwav = fwhm
    if filter eq 'K'  then obs[o].wav =  2.20*10000   ; override filtwv
    if filter eq 'Ks' then obs[o].wav =  2.15*10000
    if filter eq 'Kp' then obs[o].wav =  2.12*10000
    if filter eq 'K'  then obs[o].fwhmwav = 0.33*10000
    if filter eq 'Ks' then obs[o].fwhmwav = 0.31*10000
    if filter eq 'Kp' then obs[o].fwhmwav = 0.35*10000
    obs[o].abmag = abmag
    obs[o].stdmag = stdmag
    obs[o].emag = emag
    obs[o].uplim = uplim
    if uplim eq 0 or keyword_set(limflux) then begin
      obs[o].flux = mag2ujy(abmag,'AB')
      if uplim eq 0 then obs[o].fluxerr = mag2ujy(abmag-emag,'AB')-obs[o].flux
    endif else begin
      obs[o].flux = 0.
      obs[o].fluxerr = mag2ujy(abmag,'AB') / limsigma
    endelse
    obs[o].tel = tel
    obs[o].date = date
    obs[o].ref = ref

    o = o + 1

    limstr = ''
    if uplim then limstr = '(limit)'
    if keyword_set(loud) then print, clip(filter,5), '  ', fpr(abmag,2.2), '+/-', fpr(emag,2.2), '   ', limstr
  endelse

endfor
close, 1

obs = obs[0:o-1]
galaxies = galaxies[0:g-1]

return, obs
 
end

