function readkewley
   
  common galbuilder, galbuilderpath
  if n_elements(galbuilderpath) eq 0 then galbuilderpath = getgalbuilderpath()


   readcol, galbuilderpath+'kewley.dat', s, q0, q1, q2, q3, q4, q5, q6, format='a,f,f,f,f,f,f,f', /silent

   all = fltarr(7, n_elements(q0))
   all[0,*] = q0
   all[1,*] = q1
   all[2,*] = q2
   all[3,*] = q3
   all[4,*] = q4
   all[5,*] = q5
   all[6,*] = q6

   kewley = {q:fltarr(7), logniihalpha:fltarr(5,7), logniisii:fltarr(5,7), logniioii:fltarr(5,7), logniioiii:fltarr(5,7), oiihalpha:fltarr(4,7), $ 
             z:fltarr(8), logoiiioii:fltarr(4,8)}

   kewley.q = all[*,0]
   kewley.logniihalpha = transpose(all[*,1:5])
   kewley.logniisii  = transpose(all[*,6:10])
   kewley.logniioii  = transpose(all[*,11:15])
   kewley.logniioiii = transpose(all[*,16:20])

  kewley.oiihalpha = [[-2564.67,847.554,-92.9404,3.38261], $
[-2877.94,955.234,-105.245,3.85016], $
[-2281.80,754.840,-82.8388,3.01667], $
[-1432.67,470.545,-51.2139,1.84750], $
[-786.096,256.059,-27.6048,0.984957],[-786.096,256.059,-27.6048,0.984957],[-786.096,256.059,-27.6048,0.984957]]
; note the highest ionization pars weren't given



   readcol, galbuilderpath+'kewleyo.dat', s, z0, z1, z2, z3, z4, z5, z6, z7, format='a,f,f,f,f,f,f,f', /silent

   all = fltarr(8, n_elements(z0))
   all[0,*] = z0
   all[1,*] = z1
   all[2,*] = z2
   all[3,*] = z3
   all[4,*] = z4
   all[5,*] = z5
   all[6,*] = z6
   all[7,*] = z7

   kewley.z = all[*,0]
   kewley.logoiiioii  = transpose(all[*,1:4])


   return, kewley
end

